\name{linkR-package}
\alias{linkR-package}

\alias{angleOnCircleFromPoint}
\alias{applySolveChain}
\alias{avectors}
\alias{circlePoint}
\alias{combineLinkages}
\alias{copyTransformation}
\alias{cprod}
\alias{CSToEA}
\alias{defineCircle}
\alias{distPointToLine}
\alias{distPointToPlane}
\alias{distPointToPoint}
\alias{drawLinkage}
\alias{findOptimalPointAlignment}
\alias{intersectCircles}
\alias{intersectSphereLine}
\alias{linkR_examples}
\alias{pointNormalOnLine}
\alias{pointOnPlaneFromPoints}
\alias{pointPlaneProj}
\alias{proj3DTo2D}
\alias{reverseLinkage}
\alias{rotateBody}
\alias{rotationMatrixToEP}
\alias{rotationMatrixZYX}
\alias{setCoordinateAxes}
\alias{tMatrixDC}
\alias{tMatrixEP}
\alias{uvector}
\alias{vectorsToEP}
\alias{vorthogonal}
\alias{applyTransformationsChain}
\alias{connJointSeq}
\alias{intersectCirclePlane}
\alias{linkageKinematics}
\alias{pointsInPlaneFromPoints}
\alias{solveKinematicChain}

\docType{package}
\title{3D lever and linkage mechanism modeling}
\description{The linkR package for R provides a toolkit for creating models of 2D and 3D linkage networks, predicting motion, force and torque outputs and calculating linkage mechanical properties such as motion, force and torque transmission ratios. Users in the fields of engineering and biomechanics will find linkR particularly useful. linkR works with the R package \href{http://cran.r-project.org/package=svgViewR}{svgViewR}, enabling users to create 3D interactive animations of linkage models. Please see \href{http://home.uchicago.edu/~aolsen/software/linkr.shtml}{linkR Resources} for a tutorial on how to use the linkR package and the \href{http://home.uchicago.edu/~aolsen/software/linkr/examples.shtml}{linkR example gallery} for several examples (code and animations) of different linkages that can be created using linkR. For instructions on how to view svgViewR animations, please see \href{http://home.uchicago.edu/~aolsen/software/svgviewr/interactive.shtml}{svgViewR interactive commands}.
}
\details{
\tabular{ll}{
Package: \tab linkR\cr
Type: \tab Package\cr
Version: \tab 1.0.1\cr
Date: \tab 2015-06-18\cr
License: \tab GPL (>= 2)\cr
}
}
\author{
Aaron Olsen
Maintainer: Aaron Olsen <aolsen@uchicago.edu>
}